;; -*- mode: Lisp; Syntax: Common-Lisp; Package: cells; -*-
#|

    Hunchncells -- Cells, Parenscript, and HTML

Copyright (C) 2008 by Andy Chambers

This library is free software; you can redistribute it and/or
modify it under the terms of the Lisp Lesser GNU Public License
 (http://opensource.franz.com/preamble.html), known as the LLGPL.

This library is distributed  WITHOUT ANY WARRANTY; without even 
the implied warranty of MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  

See the Lisp Lesser GNU Public License for more details.

|#

(in-package :openair)

(progn
  (declaim (optimize (debug 3) (speed 0) (safety 1) (compilation-speed 0))))

;;; Vanilla HTML

(defhtml form ()
    ()
  (:attrs form
   :action (:-method :method) :enctype 
   :accept :name :onsubmit 
   :onreset :accept-charset))

(defhtml input ()
    ()
  (:attrs input
   :name :value :checked (:-type :type)
   :size :maxlength)
  (:default-initargs
      :-type "text"
    :value (c-in nil)))

(defmethod do-send ((self input) new old)
  (declare (ignore new))
  (not old))

(defhtml label ()
    ()
  (:attrs label
   :for :accesskey :onfocus :onblur))

(defhtml textarea ()
    ()
  (:attrs textarea
   :name :rows :cols :disabled :readonly :tabindex 
   :accesskey :onfocus :onblur :onselect :onchange))

(defhtml select ()
    ()
  (:attrs select
  :name :size :multiple :disabled :tabindex 
  :onfocus :onblur :onchange)
  (:default-initargs
    :value (c-in nil)))

(defhtml option ()
    ()
  (:attrs option
   :name :size :multiple :disabled :tabindex 
   :onfocus :onblur :onchange
   :label :value))

(defhtml button ()
  ()
  (:attrs button
    :name :value (:-type :type)
    :disabled :tabindex :accesskey :onfocus :onblur)
  (:default-initargs
    :value (c-in nil)))


;;; Higher Level Widgets

(defmacro mk-checkbox (label attribute &key top-args label-args input-args)
 `(mk-div (,@top-args)
    (mk-label (,@label-args :for ,(symbol-name attribute))
      ,label)
    (mk-input (,@input-args
               :md-name ',attribute
               :name ,(symbol-name attribute) :id ,(symbol-name attribute)
               :-type "checkbox"
               ;
               ; I am guessing that on these next two we have to actually test
               ; for whatever Ajax considers truth 
               :
               :checked (c? (^value))
               :value (c-in nil)))))



		 
